/* cmi.h
**
** intermediate interface for cli.h and redirect.h
**
*/
#ifndef _CMI_H
#define _CMI_H

typedef int (*cmdfunc) (int nargs, char *argv[]);
typedef int (*argparser) (char *line, int *nargs, char *argv[]);

typedef enum {
    st_HOLD=0, st_AUTHEN=1, st_AUTHOR=2, st_TRANSACT=4, st_UPDATE=8
} State_t;

#define st_ALL (st_AUTHEN|st_AUTHOR|st_TRANSACT|st_UPDATE)
#define st_CAPA (st_AUTHEN|st_AUTHOR|st_TRANSACT)

struct cstruct {
    char *cmdname;
    int minargs, maxargs, validstates;
    State_t newstate;
    cmdfunc action;
    argparser ap;
};

#endif /* defined(_CMI_H) */
