/* kvlist.h
**
** Interface file for `kvlist.c
** (associative array of string (key, data) pairs.)
**
*/
#ifndef _HASH_H
#define _HASH_H

#include "BBStree.h"

typedef struct {
    BBStree_t t;
} kvlist_t;

typedef struct kvitems_s *kvitems_t;
struct kvitems_s {
    kvitems_t next;
    char *value;
};

/* Initialisiere ein assoziatives Array */
void kvlist_init (kvlist_t *al);

/* Fge ein neues Schlssel/Wert-Paar ein, oder hnge den Wert an die Liste
** von bereits zu diesem existierenden Werten am Ende an.
*/
extern int kvlist_insert (kvlist_t *al, char *key, char *value);

/* Suche nach einem Schlssel und gib die Liste der zugehrigen Werte zurck
** - oder NULL, falls der Schlssel nicht gefunden wurde.
*/
extern kvitems_t kvlist_lookup (kvlist_t *al, char *key);

/* Gib eine Liste smtlicher existierender Schlssel zurck - oder NULL, falls
** das Array leer ist.
*/
extern kvitems_t kvlist_keys (kvlist_t *al);

/* Lsche den durch den Schlssel angegebenen Eintrag aus dem assoziativen
** Array.
*/
extern int kvlist_delete (kvlist_t *al, char *key);

extern void kvlist_remove (kvlist_t *al);

#endif /* defined(_HASH_H) */
